﻿Type=StaticCode
Version=3.48
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
#ExcludeFromLibrary : True
'Scale Code module
' Version 1.4		2013.11.29
' amended error with height and width <0
'
' Version 1.3		2013.11.16
' added ScaleAllX and ScaleViewX
' this scaling uses only the X scale factor
'
' Version 1.2 	2013.09.18
' added HorizontalScrollView
'
' Version 1.1 
' added other reference layouts
' the original AutoScale the reference screen is 320/480/160
' in the new version you can set any other screen like 800/1280/160
'
' Version 1.0 orginal

Sub Process_Globals
' Designer Scripts AutoScale formula
'	Delta = ((100%x + 100%y) / (320dip + 430dip) - 1)
'	Rate = 0.5 'value between 0 to 1. 
'	Scale = 1 + Rate * Delta
End Sub


'Centers vertically the given view on the screen
Public Sub setVerticalCenter(v As View)
	v.Top = (100%y - v.Height) / 2
End Sub
Public Sub getVerticalCenter(v As View)  As Int
	Return v.Top +(v.Height/ 2)
End Sub
public Sub setVerticalCenter2(v As View,nV As Int)
	v.Top=nV-v.Height/2
End Sub
public Sub setHorizontalCenter(v As View)
	v.Left=(100%x-v.Width)/2
End Sub
public Sub getHorizontalCenter(v As View)
	Return v.Left+v.Width/2
End Sub
public Sub setHorizontalCenter2(v As View,nW)
	v.Left=nW-v.Width/2
End Sub
'Centers vertically the given view on the screen
'between vTop and vBottom
'Public Sub VerticalCenter2(v As View, vTop As View, vBottom As View)
'	If IsActivity(v) Then
'		ToastMessageShow("The view is an Activity !", False)
'		Return
'	Else	
'		If IsActivity(vTop) Then
'			If IsActivity(vBottom) Then
'				v.Top = (100%y - v.Height) / 2
'			Else
'				v.Top = (vBottom.Top - v.Height) / 2
'			End If
'		Else
'			If IsActivity(vBottom) Then
'				v.Top = vTop.Top + vTop.Height + (100%y - (vTop.Top + vTop.Height) - v.Height) / 2
'			Else
'				v.Top = vTop.Top + vTop.Height + (vBottom.Top - (vTop.Top + vTop.Height) - v.Height) / 2
'			End If
'		End If
'	End If
'End Sub

'Set the Left property of the given view 
'according to the given xRight coordinate and the views Width property
Sub SetRight(v As View, xRight As Int)
	v.Left = xRight - v.Width
End Sub

'Set the Top property of the given view 
'according to the given yBottom coordinate and the views Height property
Sub SetBottom(v As View, yBottom As Int)
	v.Top = yBottom - v.Height
End Sub

'Set the view Left and Width properties to fill the space 
'between the two coordinates xLeft and xRight
Public Sub SetLeftAndRight(v As View, xLeft As Int, xRight As Int)
	' take the correct coordinates event if they are permuted
	v.Left = Min(xLeft, xRight)
	v.Width = Max(xLeft, xRight) - v.Left 
End Sub

'Set the view Left and Width properties to fill the space 
'between the two views vLeft and vRight
'if the Left coordinate should be 0 set vLeft to the Activity
'if the Right coordinate should be 100%x set vRight to the Activity
'Public Sub SetLeftAndRight2(v As View, vLeft As View, dxL As Int, vRight As View, dxR As Int)
'	
'	' if vLeft is on the right of vRight pernutates the two views
'	If IsActivity(vLeft) = False And IsActivity(vRight) = False Then
'		If vLeft.Left > vRight.Left Then
'			Dim v1 As View
'			v1 = vLeft
'			vLeft = vRight
'			vRight = v1
'		End If
'	End If
'	
'	If IsActivity(vLeft) Then
'		v.Left = dxL
'		If IsActivity(vRight) Then
'			v.Width = 100%x - dxL - dxR
'		Else
'			v.Width = vRight.Left - dxL - dxR
'		End If
'	Else
'		v.Left = vLeft.Left + vLeft.Width + dxL
'		If IsActivity(vRight) Then
'			v.Width = 100%x - v.Left
'		Else
'			v.Width = vRight.Left - v.Left - dxR
'		End If
'	End If
'End Sub

'Set the view Top and Height properties to fill the space 
'between  the two coordinates yTop and yBottom
Public Sub SetTopAndBottom(v As View, yTop As Int, yBottom As Int)
	' take the correct coordinates event if they are permuted
	v.Top = Min(yTop, yBottom)
	v.Height = Max(yTop, yBottom) - v.Top 
End Sub

'Set the view Top and Height properties to fill the space 
'between the two views vTop and vBottom
'if the Top coordinate should be 0 set vTop to the Activity
'if the Bottom coordinate should be 100%y set vBottom to the Activity
'Public Sub SetTopAndBottom2(v As View, vTop As View, dyT As Int, vBottom As View, dyB As Int)
'	' return if v is an Activity
'	If IsActivity(v) Then
''		ToastMessageShow("The view is an Activity !", False)
'		Return
'	End If
'	
'	If IsActivity(vTop) = False And IsActivity(vBottom) = False Then
'		' if vTop is below vBottom.Top permutes the two views
'		If vTop.Top > vBottom.Top Then
'			Dim v1 As View
'			v1 = vTop
'			vTop = vBottom
'			vBottom = v1
'		End If
'	End If
'	
'	If IsActivity(vTop) Then
'		v.Top = dyT
'		If IsActivity(vBottom) Then
'			v.Height = 100%y - dyT - dyB
'		Else
'			v.Height = vBottom.Top - dyT - dyB
'		End If
'	Else
'		v.Top = vTop.Top + vTop.Height + dyT
'		If IsActivity(vBottom) Then
'			v.Height = 100%y - v.Top - dyB
'		Else
'			v.Height = vBottom.Top - v.Top - dyB
'		End If
'	End If
'End Sub

'Returns the Right coordinate of the given view
Public Sub Right(v As View) As Int
	Return v.Left + v.Width
End Sub

'Returns the Bottom coordinate of the given view
Public Sub Bottom(v As View) As Int
	Return v.Top + v.Height
End Sub

''Returns True if the view v is a Panel otherwise False
''Needed to check if the view is a Panel or an Activity
'Public Sub IsPanel(v As View) As Boolean
'	If GetType(v) = "anywheresoftware.b4a.BALayout" Then
'		Dim obj As Object
'		obj = GetParent(v)
'		If GetType(obj) = "android.widget.FrameLayout" Then
'			Return False
'		Else
'			Return True
'		End If	
'	Else
'		Return False
'	End If
'End Sub
'
''Returns True If the View v Is an Activity otherwise False
''Needed to check if the view is a Panel or an Activity
'Public Sub IsActivity(v As View) As Boolean
'	Dim obj As Object
'	obj = GetParent(v)
'	If GetType(obj) = "android.widget.FrameLayout" Then
'		Return True
'	Else
'		Return False
'	End If
'End Sub